代码随想录算法训练营天 第九章 五十八天| 739. 每日温度 496.下一个更大元素 I

代码随想录算法训练营天 第九章 五十八天| 739. 每日温度 496.下一个更大元素 I

739. 每日温度

class Solution {
    public int[] dailyTemperatures(int[] temperatures) {
        // 单调递增是这么写
        int len = temperatures.length;
        int[] result = new int[len];

        Deque<Integer> queue = new LinkedList<>();
        // 这个放的是下标
        queue.push(0);
        for (int i = 1; i < len; i++) {
            if (temperatures[i] <= temperatures[queue.peek()]) {
                queue.push(i);
            } else {
                // 遇到
                while (!queue.isEmpty() && temperatures[i]>temperatures[queue.peek()]){
                    // 这个才是重点
                    result[queue.peek()] = i - queue.peek();
                    queue.pop();
                }
                // 这个也是
                queue.push(i);
            }
        }

        return result;
    }
}

496.下一个更大元素 I

class Solution {
    public int[] nextGreaterElement(int[] nums1, int[] nums2) {
        // 单调栈 递增是4,3,2,1 递减是1,2,3,4
        //  我的第一想法就是模拟。题解是先去处理nums2
        int len1 = nums1.length;
        int len2 = nums2.length;
        int[] result = new int[len1];

        if (len1 == 0) {
            return result;
        }
        HashMap<Integer, Integer> map = new HashMap<>();
        for (int i = 0; i < len1; i++) {
            result[i] = -1;
            map.put(nums1[i],i);
        }

        Stack<Integer> stack = new Stack<>();
        // 放的是下标
        stack.push(0);
        for (int i = 1; i < len2; i++) {
            if (nums2[i] <= nums2[stack.peek()]) {
                stack.push(i);
            } else {
                while (!stack.isEmpty() && nums2[i] > nums2[stack.peek()]) {
                    // 说明在nums1中有这个元素
                    if (map.containsKey(nums2[stack.peek()])){
                        result[map.get(nums2[stack.peek()])] = nums2[i];
                    }
                    // 不管什么都要弹出,不然就不是单调栈了
                    stack.pop();
                }
                //不要忘记放入
                stack.push(i);
            }
        }
        return result;

    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
第二十二算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值